#include "player.h"

CPlayer  player;

//-----------------------------------------------------------------------------------------
CPlayer::CPlayer()
{
    dir = 0;
}

//-----------------------------------------------------------------------------------------
CVec2   CPlayer::getPosFromLocal(CVec2 localPos)
{
    CVec2   newLocalPos;

    switch (dir)
    {
        case 0: // up
            newLocalPos = localPos;
            break;

        case 1: // left
            newLocalPos.x = localPos.y;
            newLocalPos.y = -localPos.x;
            break;

        case 2: // down
            newLocalPos.x = -localPos.x;
            newLocalPos.y = -localPos.y;
            break;

        case 3: // right
            newLocalPos.x = -localPos.y;
            newLocalPos.y = localPos.x;
            break;
    }

    return pos + newLocalPos;
}

//-----------------------------------------------------------------------------------------
EWallSide   CPlayer::getWallSide(EWallSide side)
{
    static const EWallSide rotatedSides[4][4] =
    {
        {eWallSideUp,    eWallSideDown,  eWallSideLeft,  eWallSideRight}, // up
        {eWallSideLeft,  eWallSideRight, eWallSideDown,  eWallSideUp},    // left
        {eWallSideDown,  eWallSideUp,    eWallSideRight, eWallSideLeft},  // down
        {eWallSideRight, eWallSideLeft,  eWallSideUp,    eWallSideDown}   // right
    };
    return rotatedSides[dir][side];
}
